#include <Servo.h> 

#define IRsensorPin 18
#define IRledPin1 17
#define IRledPin2 11
#define EnableServo 12
#define BuzzerPin 13
#define ButtonPin 2
#define Red 3
#define Green 5
#define Blue 6


Servo Lleg;  // create servo object to control a servo 
Servo Rleg;
Servo Lfoot;
Servo Rfoot;

int RFcenter = 80;    // variable to store the center servo position 
int LLcenter = 80;
int RLcenter = 87;
int LFcenter = 75;
int tAngle = 30; //tilt angle
int uAngle = 35; //turn angle
int sAngle = 35; //swing angle

void setup(){
  Lleg.attach(7);  // attaches the servo on pin x to the servo object 
  Rleg.attach(10);  // attaches the servo on pin x to the servo object 
  Lfoot.attach(8);  // attaches the servo on pin x to the servo object 
  Rfoot.attach(9);  // attaches the servo on pin x to the servo object 

  pinMode(EnableServo,OUTPUT); 
  digitalWrite(EnableServo,HIGH); //this turns on the power to the servos
  CenterServos(); //center the servos
  delay(500);
  digitalWrite(EnableServo,LOW); //turn power off after centering

  pinMode(Red, OUTPUT);
  digitalWrite(Red, LOW);
  pinMode(Blue, OUTPUT);
  digitalWrite(Blue, LOW);
  pinMode(Green, OUTPUT);
  digitalWrite(Green, LOW);
  
  pinMode(IRledPin1, OUTPUT);
  digitalWrite(IRledPin1, LOW);
  pinMode(IRledPin2, OUTPUT);
  digitalWrite(IRledPin2, LOW);

  pinMode(BuzzerPin, OUTPUT);
  digitalWrite(BuzzerPin, LOW);
  //Buzzer.PlayMelody();
  
  pinMode(ButtonPin, INPUT);
  digitalWrite(ButtonPin, HIGH); //pull up activated
  
  Serial.begin(19200);
  Serial.print("Ready");

  //while (digitalRead(ButtonPin) != LOW){ 
    //do nothing until the button pressed
  //}
    BuzzerBeep();
  for(int i=0;i<5;++i){
    delay(1000);
  }
    BuzzerBeep();
}



void loop(){
  //check for obstacles, if none, go Forward, if found, turn the other way
  CheckObstacle();
}



void CheckObstacle(){
  int Obstacle=0;
  IR38Write(IRledPin2); //turn on Left IR LED
  if (digitalRead(IRsensorPin)==LOW){ //check sensor
    BuzzerBeep();
    Obstacle=Obstacle+1;
  }
  IR38Write(IRledPin1); //turn on Right IR LED
  if (digitalRead(IRsensorPin)==LOW){ //check sensor
    BuzzerBeep();
    Obstacle=Obstacle+2;
  }
  switch (Obstacle){
    case 0: //no object
      digitalWrite(Green, HIGH);
      digitalWrite(Red, HIGH);
      Forward(1,30); //one step Forward
      digitalWrite(Green, LOW);
      digitalWrite(Red, LOW);
      break;
    case 1: //object on Left
      digitalWrite(Green, HIGH);
      TurnRight(2,30);
      digitalWrite(Green, LOW);
      break;
    case 2: //object on Right
      digitalWrite(Blue, HIGH);
      TurnLeft(2,30);
      digitalWrite(Blue, LOW);
      break;
    case 3: //obect in Front (both Left and Right detect the object)
      digitalWrite(Red, HIGH);
      TurnLeft(4,30); //turn around
      digitalWrite(Red, LOW);
      break;
  }
}

void IR38Write(byte LedPin) {
  for(int i = 0; i <= 384; i++) { //10ms burst of 38kHz signal
    digitalWrite(LedPin, HIGH);
    delayMicroseconds(13);
    digitalWrite(LedPin, LOW);
    delayMicroseconds(13);
  }
}

void CenterServos() 
{ 
    Lleg.write(LLcenter);              // tell servo to go to position in variable 'center' 
    Rleg.write(RLcenter);              // tell servo to go to position in variable 'center' 
    Lfoot.write(LFcenter);              // tell servo to go to position in variable 'center' 
    Rfoot.write(RFcenter);              // tell servo to go to position in variable 'center' 
    delay(100);                     // waits 100ms for the servos to reach the position 
}

void BuzzerBeep(){
    digitalWrite(BuzzerPin, HIGH);
    delay(100);
    digitalWrite(BuzzerPin, LOW);
}


